Developer Documentation

Signals | Public Member Functions | Private Attributes | List of all members
ACG::SceneGraph::QtManipulatorNode Class Reference

`#include <ACG/QtScenegraph/QtManipulatorNode.hh>`

Inheritance diagram for ACG::SceneGraph::QtManipulatorNode:

## Signals
void | manipulatorMoved (QtManipulatorNode *_node, QMouseEvent *_event)
void | visibilityChanged (QtManipulatorNode *_node, bool _visible)
void | positionChanged (QtManipulatorNode *_node)

## Public Member Functions
| QtManipulatorNode (BaseNode *_parent=0, const std::string &_name="<QtManipulatorNode>")
| Default constructor.
| ~QtManipulatorNode ()
| Destructor.
| ACG_CLASSNAME (QtManipulatorNode)
| class name
void | mouseEvent (GLState &_state, QMouseEvent *_event) override
| get mouse events
void | setIdentifier (int _id)
| Set an identifier for that manipulator.
int | getIdentifier ()
| Get an identifier for that manipulator.
void | show ()
void | hide ()
void | rotate (double _angle, const Vec3d &_axis)
void | translate (double _s)
void | set_center (const Vec3d &_c)
Public Member Functions inherited from ACG::SceneGraph::ManipulatorNode
| ManipulatorNode (BaseNode *_parent=0, const std::string &_name="<ManipulatorNode>")
| Default constructor.
| ~ManipulatorNode ()
| Destructor.
| ACG_CLASSNAME (ManipulatorNode)
| class name
virtual void | setIdentity () override
void | set_draw_cylinder (bool _b)
| set draw_cylinder_
bool | draw_cylinder () const
| get drawCylinder
void | set_direction (Vec3d &_v)
Vec3d | direction () const
void | set_size (double _size)
| set cylindersize (height + radius)
double | size () const
| get cylindersize
void | translate (double _s)
| translate in cylinder direction
void | draw (GLState &_state, const DrawModes::DrawMode &_drawMode) override
| draw the cylinder (if enabled)
void | pick (GLState &_state, PickTarget _target) override
| picking
bool | touched ()
void | reset_touched ()
| Reset the touched flag ( see touched for details )
Public Member Functions inherited from ACG::SceneGraph::TransformNode
| TransformNode (BaseNode *_parent=0, const std::string &_name="<TransformNode>")
| Constructor.
virtual | ~TransformNode ()
| Destructor.
| ACG_CLASSNAME (TransformNode)
| set name
void | enter (GLState &_state, const DrawModes::DrawMode &_drawmode) override
| set current GL-color and GL-material
void | leave (GLState &_state, const DrawModes::DrawMode &_drawmode) override
| restores original GL-color and GL-material
void | set_center (const Vec3d &_c)
| set center
const Vec3d & | center () const
| get center
void | loadIdentity ()
void | translate (const Vec3d &_v)
| Add a translation to the current Transformation.
void | setTranslation (const Vec3d &_v)
| translation setter
void | rotate (double _angle, const Vec3d &_axis)
void | setRotation (const Quaterniond &rotation)
| rotation setter
void | scale (double _s)
| Add scaling to the current Transformation.
void | scale (const Vec3d &_s)
| Add scaling to the current Transformation.
void | scale (const GLMatrixd &_m)
| Add scaling to the current Transformation.
const GLMatrixd & | matrix () const
| Returns a const reference to the current transformation matrix.
const GLMatrixd & | inverse_matrix () const
| return inverse matrix
void | rotation (Vec3d &_axis, double &_angle) const
| return rotation axis & angle
const GLMatrixd & | rotation () const
| return rotation matrix
const GLMatrixd & | inverse_rotation () const
| return inverse rotation matrix
const Vec3d & | translation () const
| returns ref. to translation vector
const GLMatrixd & | scale () const
| return scale matrix
const GLMatrixd & | inverse_scale () const
| return inverse scale matrix
bool | apply_transformation ()
void | apply_transformation (bool _applyTransformation)
bool | is2D ()
void | set2D (bool _2d)
bool | isPerSkeletonObject ()
void | setPerSkeletonObject (bool _is)
void | setPerSkeletonModelView (GLMatrixd _is)
void | ortho2DMode (GLState &_state)
void | perSkeletonMode (GLState &_state)
void | update2DOffset (ACG::Vec2d _offset)
void | scale2D (double _scale)
void | setImageDimensions (ACG::Vec2i _dim)
Public Member Functions inherited from ACG::SceneGraph::ACG::SceneGraph::BaseNode
| BaseNode (BaseNode *_parent=0, std::string _name="<unknown>")
| Default constructor.
| BaseNode (BaseNode *_parent, BaseNode *_child, std::string _name="<unknown>")
| Put this node between _parent and _child.
virtual | ~BaseNode ()
| Destructor.
void | delete_subtree ()
| Delete the whole subtree of this node. More...
virtual const std::string & | className () const =0
| Return class name (implemented by the ACG_CLASSNAME macro)
virtual DrawModes::DrawMode | availableDrawModes () const
virtual void | boundingBox (Vec3d &, Vec3d &)
virtual void | enter (GLState &, const DrawModes::DrawMode &)
virtual void | enter (IRenderer *, GLState &_state, const DrawModes::DrawMode &_drawMode)
virtual void | draw (GLState &, const DrawModes::DrawMode &)
| Draw this node using the draw modes _drawMode. More...
virtual void | getRenderObjects (IRenderer *_renderer, GLState &_state, const DrawModes::DrawMode &_drawMode, const Material *_mat)
| Deferred draw call with shader based renderer. More...
virtual void | leave (GLState &, const DrawModes::DrawMode &)
virtual void | leave (IRenderer *, GLState &_state, const DrawModes::DrawMode &_drawMode)
virtual void | enterPick (GLState &_state, PickTarget _target, const DrawModes::DrawMode &_drawMode)
virtual void | pick (GLState &, PickTarget)
virtual void | leavePick (GLState &_state, PickTarget _target, const DrawModes::DrawMode &_drawMode)
void | enablePicking (bool _enable)
bool | pickingEnabled ()
virtual void | mouseEvent (GLState &, QMouseEvent *)
| Handle mouse event (some interaction, e.g. modeling)
void | setDirty (bool _dirty=true)
| mark node for redrawn
bool | isDirty () const
| Check if node should be redrawn.
ChildIter | childrenBegin ()
| Returns: begin-iterator of children.
ConstChildIter | childrenBegin () const
| Same but `cont`.
ChildIter | childrenEnd ()
| Returns: end-iterator of children.
ConstChildIter | childrenEnd () const
| Same but `const`.
ChildRIter | childrenRBegin ()
| Returns: reverse begin-iterator of children.
ConstChildRIter | childrenRBegin () const
| Same but const.
ChildRIter | childrenREnd ()
| Returns: reverse end-iterator of children.
ConstChildRIter | childrenREnd () const
| Same but `const`.
void | push_back (BaseNode *_node)
| Insert _node at the end of the list of children.
void | remove (ChildIter _pos)
size_t | nChildren () const
| number of children
ChildIter | find (BaseNode *_node)
BaseNode * | find (const std::string &_name)
BaseNode * | parent ()
| Get the nodes parent node.
const BaseNode * | parent () const
| Get the nodes parent node.
void | set_parent (BaseNode *_parent)
| Set the parent of this node. More...
StatusMode | status () const
| Get node's status.
void | set_status (StatusMode _s)
| Set the status of this node.
void | hide ()
| Hide Node: set status to HideNode.
void | show ()
| Show node: set status to Active.
bool | visible ()
| Is node visible (status == Active)?
bool | hidden ()
| Is node not visible (status != Active)?
std::string | name () const
| Returns: name of node (needs not be unique)
void | name (const std::string &_name)
| rename a node
unsigned int | id () const
DrawModes::DrawMode | drawMode () const
| Return the own draw modes of this node.
void | drawMode (DrawModes::DrawMode _drawMode)
unsigned int | traverseMode () const
| Return how the node should be traversed.
void | setTraverseMode (unsigned int _mode)
| Set traverse mode for node.
MultipassBitMask | multipassStatus () const
| Get the current multipass settings for the nodes status functions. More...
void | setMultipassStatus (const MultipassBitMask _passStatus)
| Set multipass settings for the nodes status functions. More...
void | multipassStatusSetActive (const unsigned int _i, bool _active)
| Set multipass status to traverse in a specific pass. More...
bool | multipassStatusActive (const unsigned int _i) const
| Get multipass status to traverse in a specific pass. More...
MultipassBitMask | multipassNode () const
| Get the current multipass settings for the node. More...
void | setMultipassNode (const MultipassBitMask _passNode)
| Set multipass settings for the node. More...
void | multipassNodeSetActive (const unsigned int _i, bool _active)
| Set Node status to traverse in a specific pass. More...
bool | multipassNodeActive (const unsigned int _i) const
| Get Node status to traverse in a specific pass. More...
void | setRenderObjectShaders (const std::string &_vertexShaderFile, const std::string &_geometryShaderFile, const std::string &_fragmentShaderFile, bool _relativePaths=true, DrawModes::DrawModePrimitive _primitiveType=DrawModes::PRIMITIVE_POLYGON)
| Set custom shaders. More...
void | setRenderObjectShaders (const std::string &_vertexShaderFile, const std::string &_tessControlShaderFile, const std::string &_tessEvalShaderFile, const std::string &_geometryShaderFile, const std::string &_fragmentShaderFile, bool _relativePaths=true, DrawModes::DrawModePrimitive _primitiveType=DrawModes::PRIMITIVE_POLYGON)
| Set custom shaders. More...
void | setRenderObjectUniformPool (const GLSL::UniformPool *_pool)
| Set uniforms for shader based rendering. More...
const GLSL::UniformPool * | getRenderObjectUniformPool ()
| Get uniforms for shader based rendering. More...
void | setRenderObjectTexture (int _samplerSlot, GLuint _texId, GLenum _texType=GL_TEXTURE_2D)
| Set textures for shader based rendering. More...
void | setRenderObjectModifier (RenderObjectModifier *_modifier)
| Set modifier for render objects. More...
RenderObjectModifier * | getRenderObjectModifier ()
| Get render-object modifier. More...
void | applyRenderObjectSettings (DrawModes::DrawModePrimitive _primitive, RenderObject *_obj) const
| Set shaders, textures and uniforms as provided by user to a render-object. More...

## Private Attributes
int | identifier_

## Additional Inherited Members
Public Types inherited from ACG::SceneGraph::ACG::SceneGraph::BaseNode
enum | StatusMode { Active = 0x1, HideNode = 0x2, HideChildren = 0x4, HideSubtree = 0x8 }
| Status modi. More...
enum | TraverseMode { NodeFirst = 0x1, ChildrenFirst = 0x2, SecondPass = 0x4 }
| Node traverse types. More...
typedef std::vector< BaseNode * >::const_iterator | ConstChildIter
| allows to iterate over children
typedef std::vector< BaseNode * >::iterator | ChildIter
| allows to iterate over children
typedef std::vector< BaseNode * >::const_reverse_iterator | ConstChildRIter
| allows to reverse iterate over children
typedef std::vector< BaseNode * >::reverse_iterator | ChildRIter
| allows to reverse iterate over children
enum | PASSES { NOPASS = 0, ALLPASSES = 1 << 0, PASS_1 = 1 << 1, PASS_2 = 1 << 2, PASS_3 = 1 << 3, PASS_4 = 1 << 4, PASS_5 = 1 << 5, PASS_6 = 1 << 6, PASS_7 = 1 << 7, PASS_8 = 1 << 8 }
| This enum should be used to enable rendering of a node in different.
typedef unsigned int | MultipassBitMask
| Multipass pass bit mask type.
Public Attributes inherited from ACG::SceneGraph::TransformNode
bool | is2DObject_
bool | isPerSkeletonObject_
GLMatrixd | perSkeletonModelView_
double | scaleFactor2D_
ACG::Vec2i | imageDimensions_
ACG::Vec2d | offset_

## Detailed Description

Additional overlay class for emitting signals if manipulator is moved

Definition at line 80 of file QtManipulatorNode.hh.

## Member Function Documentation

## ◆ manipulatorMoved

void ACG::SceneGraph::QtManipulatorNode::manipulatorMoved | ( | QtManipulatorNode * | _node,
|  | QMouseEvent * | _event
| ) |  |
| signal

This signal is emitted everytime the manipulator is moved Do not traverse Scenegraph when called by this function!!!!!!!

## ◆ positionChanged

void ACG::SceneGraph::QtManipulatorNode::positionChanged | ( | QtManipulatorNode * | _node | ) |
| signal

this signal is emited every time the position of the manipulator is changed

## ◆ visibilityChanged

void ACG::SceneGraph::QtManipulatorNode::visibilityChanged | ( | QtManipulatorNode * | _node,
|  | bool | _visible
| ) |  |
| signal

The visibility of this node has changed

Parameters

  _node | The node whose visibility has been changed
  _visible | Is it now visible?

The documentation for this class was generated from the following files:

- OpenFlipper/libs_required/ACG/QtScenegraph/QtManipulatorNode.hh
- OpenFlipper/libs_required/ACG/QtScenegraph/QtManipulatorNode.cc